package org.expeditee.settings.auth.secrets;

import java.util.Collection;

import org.expeditee.core.Colour;
import org.expeditee.gui.Frame;
import org.expeditee.gui.FrameIO;
import org.expeditee.items.Item;
import org.expeditee.items.Text;
import org.expeditee.setting.TextSetting;
import org.expeditee.settings.UserSettings;

public class KeyList {
	public static final TextSetting PersonalKey = new TextSetting("The AES key used to secure your profile frame - do not share with anyone!") {
		
		@Override
		public Text generateText() {
			Text t = new Text("");
    		t.setColor(Colour.BLACK);
    		t.setBackgroundColor(new Colour(0.7F, 0.7F, 0.9F));
    		t.setSize(14);
    		return t;
		}
		
		public boolean setSetting(final Text text) {
			final String value = text.getText();
			this._value.setData(value);

			String profileName = UserSettings.ProfileName.get();
			int lastNumber = FrameIO.getLastNumber(profileName);
			for (int i = 1; i <= lastNumber; i++) {
				Frame frame = FrameIO.LoadFrame(profileName + i);
				Collection<Item> items = frame.getAllItems();
				boolean found = false;
				for (Item item: items) {
					if (item.getText().compareTo("PersonalKey") == 0) {
						item.setData(this._value.getData());
						found = true;
						break;
					}
				}
				if (found) { break; }
			}
				
			return true;
		};
	};
	
	public static final TextSetting PrivateKey = new TextSetting("The RSA key used to decrypt things encrypted with your RSA public key - do not share with anyone!") {
		
		@Override
		public Text generateText() {
			Text t = new Text("");
    		t.setColor(Colour.BLACK);
    		t.setBackgroundColor(new Colour(0.7F, 0.7F, 0.9F));
    		t.setSize(14);
    		return t;
		}
		
		public void set(Text value) {
			super.set(value);
		};
		
		public boolean setSetting(final Text text) {
			System.err.println("KeyList::PrivateKey::setSetting:setting private key for " + UserSettings.UserName.get() + " to: " + text.getText());
			final String value = text.getText();
			this._value.setData(value);
			
			String profileName = UserSettings.ProfileName.get();
			int lastNumber = FrameIO.getLastNumber(profileName);
			for (int i = 1; i <= lastNumber; i++) {
				Frame frame = FrameIO.LoadFrame(profileName + i);
				Collection<Item> items = frame.getAllItems();
				boolean found = false;
				for (Item item: items) {
					if (item.getText().compareTo("PrivateKey") == 0) {
						item.setData(this._value.getData());
						found = true;
						break;
					}
				}
				if (found) { break; }
			}
			
			return true;
		};
	};
}
